# -*- coding: cp1252 -*-
# Musterlsung zu den Aufgaben 3, 4, 8 und 9 mit Python
# H. Witten, 09.12.2008

def neue_Stufe_refl(s):
    '''
    Berechnet die neue Stufe der Papierfaltungszahl
    nach dem Reflexionsgesetz.
    '''
    s_refl = ''     # Berechnung des reflektierten Strings
    for i in range(len(s)-1,-1,-1): # Indizes von s rckwrts
        if s[i] == '1': s_refl += '0'
        elif s[i] == '0': s_refl += '1'
    return s+'1'+s_refl     # Das Reflexionsgesetz

def neue_Stufe(s):
    '''
    Berechnet die neue Stufe der Papierfaltungszahl
    nach dem Inflationsgesetz.
    Beispiel:
     1 0 1 0 1 0 1 0 => s_infl (= 4*'10', 4 == (7+1)/2)
      1 1 0 1 1 0 0  => s      (len(s) == 7)  
     110110011100100 => Rckgabestring von "neue_Stufe"
    '''
    s_infl = '10'*((len(s)+1)/2)
    s_neu = ''
    for i in range(len(s)):
        s_neu += s_infl[i]+s[i]
    return s_neu+'0'
    

def Papierfaltungszahl(n):
    '''
    Eingabe: Iterationsstufe n, Ausgabe: Papierfaltungszahl
    Lsung fr Aufgabe 3, wenn vor dem Ausgabestring '0.'
    angehngt wird.
    '''
    if n == 0: return ''
    s = '1'
    for i in range(n-1):
        s = neue_Stufe(s)
    return s

def Naeherung(s):
    '''
    Eingabe: Papierfaltungszahl als String mit '0' und '1'
    Ausgabe: rationaler Nherungswert fr die Papierfaltungszahl
    Berechnung mit dem Horner-Schema.
    Ab n == 5 ndert sich der ausgegebene Wert nicht mehr:
    >>> Naeherung(Papierfaltungszahl(5))
    0.85073618820186725
    Lsung fr Aufgabe 4
    '''
    hilf = int(s[len(s)-1]) # Die letzte Ziffer von s
    for i in range(len(s)-2,-1,-1): # Indizes von s rckwrts
        if s[i] == '1': hilf = 1 + 0.5*hilf
        elif s[i] == '0': hilf = 0.5*hilf
    return 0.5*hilf

import turtle 
from math import log

def TurtleInit(s):
    '''
    Initialisierung der Turtle
    Es empfiehlt sich, Python 2.6 oder bei lteren Versionen das
    xturtle-Modul von Gregor Lingl zu verwenden. Das Programm funktio-
    niert aber auch mit dem alten turtle-Modul (fr Versionen < 2.6 im
    Lieferumfang von Python enthalten).
    '''
    global n                # unschn, aber bequem
                            #(wird nur fr die Positionierung und 
                            # Skalierung der Grafik verwendet)
    n = int(log(len(s)+1)/log(2)) # Iterationstufe aus len(s) bestimmen,
                            # zur Formel s. Aufgabe 1!
    turtle.up()             # Turtle passend ausrichten
    turtle.backward(200)
    turtle.right(n*45) 
    turtle.down()           # ...jetzt kann's losgehen!!!

def Drachenmuster(s):
    '''
    Eingabe: Papierfaltungszahl als String mit '0' und '1'
    Ausgabe: die entsprechende Drachenkurve (bzw. das Drachenmuster
    in der Terminologie von Davis/Knuth). Aufruf (z. B.):
    >>> Drachenmuster(Papierfaltungszahl(5))
    Lsung fr Aufgabe 8
    '''
    TurtleInit(s)
    laenge = int(200/(n*1.5))     # ggf. ndern
    turtle.forward(laenge)
    for i in range(len(s)):
        turtle.forward(laenge)
        if s[i] == '1':   turtle.left(90)  # Linksknick
        elif s[i] == '0': turtle.right(90) # Rechtsknick
        turtle.forward(laenge)
    turtle.forward(laenge)

def Drachenkurve(s):
    '''
    Eingabe: Papierfaltungszahl als String mit '0' und '1'
    Ausgabe: die entsprechende Drachenkurve (mit abgerundeten Ecken)
    Um z. B. die Verzierung an der Mauer des Knuth'schen Hauses
    nachzuvollziehen, ruft man
    >>> Drachenkurve(Papierfaltungszahl(9))
    auf. Lsung fr Aufgabe 9
    '''
    TurtleInit(s)
    radius = int(200/(n*1.5))     # ggf. ndern
    for i in range(len(s)):
        if s[i] == '1':   turtle.circle(radius, 90)  # Linkskurve
        elif s[i] == '0': turtle.circle(-radius, 90) # Rechtskurve
